#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
#-------------------------------------------------------------------------
#    Name:  dbamon_allcharts.pl
#-------------------------------------------------------------------------
#
# Changes 
#
# 1.00 21Jul13 BB - Initial
#-------------------------------------------------------------------------
$version = "1.00"; 
$| = 1;
chop($P = `basename $0`); 
$P =~ s/\.pl$//g;

push(@INC,"/opt/dbamon/lib");

require "cgi_handlers.pl";
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

$maxrows = 250;
$from_days = 30;  #---- Default and for the menu
$stop_displaying = 0;

#---- Max these vars global
$in_categ = "";  

#---- PL and CSV Vars and FILES - Start - Should only happen 1 time
mkdir "/opt/dbamon/dat/dyn" if (! -e "/opt/dbamon/dat/dyn"); 
system("ln -s /opt/dbamon/dat/dyn /opt/dbamon/htm/dyn") if ! -e "/opt/dbamon/htm/dyn"; 

$pl_date = getdate(); 
$pl_date =~ s/\///g;
$pl_date =~ s/\://g;
$pl_date =~ s/\-/_/;
##$zdiag .= "new pl_date=($pl_date)\n"; 

$tmpdata = "/tmp/${P}_tmpdata_$$.txt"; 
$tmpout  = "/tmp/${P}_tmpout_$$.txt"; 

#---- Read WWW_Font:

#---- Old
#chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
#if ($font =~ /%/)
#{
#  $font =~ s/%/ /g;
#  $font = "'$font'";
#}
#$zdiag .= "old font=($font)\n"; 

#---- New
$font                 = &readRC("WWW_Font:");
#$table_metrics_hourly = &readRC("Table_METRICS_HOURLY:");
#$table_detail_retain  = &readRC("Table_Detail_Retain_Days:");
#$table_detail_retain  = 30 if ! $table_detail_retain; 

##$zdiag .= "new font=($font)\n"; 

$font = "arial" if ! $font;

#---- Set connect string and hostname for URLs
if ($ENV{'HTTPS'} eq "on") { $http_prefix = "https://"; } 
else                       { $http_prefix = "http://"; } 
$http_host = $http_prefix . $ENV{'HTTP_HOST'};

$script_name = $ENV{'SCRIPT_NAME'};

#---- Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

use DBI;
require "cgi_handlers.pl";

#-----------------------------------------------------------------------------
sub logMsg
#-----------------------------------------------------------------------------
{
  my ($ls_key1, $ls_key2, $ls_key3, $ls_data) = @_;
  my $sql  = "insert into dbamon.log (lo_key1, lo_key2, lo_key3, lo_data) values (\'$ls_key1\', \'$ls_key2\', \'$ls_key3\', \'$ls_data\')";
  $dbh->do($sql) || &error('Failed_on_DB_do_insert_L300');
}

#-----------------------------------------------------------------------------
sub menuInstance
#-----------------------------------------------------------------------------
{
  &msg("menuInstance - Choose a data source: 
  <p></b>
  <span $style_normal>

The purpose of this report is to create many inline DBAmon Metric Charts, easily (without having to select individual charts). The term <i>Graph Set</i> 
refers to a set of DBAmon Charts.  
<p>
<b> Available Graph Sets:  </b>
<p>
  <table bgcolor=wheat border=0 $style_normal>
  <tr bgcolor=cadetblue>
    <th> <span $style_normal>&nbsp; # &nbsp;
    <th> <span $style_normal>Graph Set Description
    <th> <span $style_normal>METRICS_DETAIL<br> Recent (L${from_days}D) <br>Unsumarized <br>Graph Sets 
    <th> <span $style_normal>METRICS_DAILY<br> Historical <br>Summarized <br>Graph Sets 

  <tr bgcolor=white> 
    <td align=right> <span $style_normal> 1. 
    <td> <span $style_normal> <b> All DBAmon Metrics, Performance and Other  </b>
    <td> <span $style_normal> <b> <a href='/cgi-bin/$P.pl?$mode,$instance,D,%'> Recent (L${from_days}D) </a>   </b>
    <td> <span $style_normal> <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,%,Avg'> Historical AVG </a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,%, Max'> Historical MAX</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,%, Min'> Historical MIN</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,%, Sum'> Historical SUM</a>   </b>

  <tr bgcolor=white> 
    <td align=right> <span $style_normal> 2. 
    <td> <span $style_normal> <b> All Performance Metrics </b>
    <td> <span $style_normal> <b> <a href='/cgi-bin/$P.pl?$mode,$instance,D,PERF%'> Recent (L${from_days}D) </a>   </b>
    <td> <span $style_normal> <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF%,Avg'> Historical AVG</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF%, Max'> Historical MAX</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF%, Min'> Historical MIN</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF%, Sum'> Historical SUM</a>   </b>

  <tr bgcolor=white> 
    <td align=right> <span $style_normal> 3. 
    <td> <span $style_normal> <b> PERF_NET% Network Performance Metrics </b>
    <td> <span $style_normal> <b> <a href='/cgi-bin/$P.pl?$mode,$instance,D,%PERF_NET%'> Recent (L${from_days}D) </a>   </b>
    <td> <span $style_normal> <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,%PERF_NET%, Avg'> Historical AVG</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF_NET%, Max'> Historical MAX</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF_NET%, Min'> Historical MIN</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF_NET%, Sum'> Historical SUM</a>   </b>

  <tr bgcolor=white> 
    <td align=right> <span $style_normal> 4. 
    <td> <span $style_normal> <b> PERF_SQL% MSSQL Performance Metrics </b>
    <td> <span $style_normal> <b> <a href='/cgi-bin/$P.pl?$mode,$instance,D,PERF_SQL%'> Recent (L${from_days}D) </a>   </b>
    <td> <span $style_normal> <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF_SQL%, Avg'> Historical AVG</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF_SQL%, Max'> Historical MAX</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF_SQL%, Min'> Historical MIN</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF_SQL%, Sum'> Historical SUM</a>   </b>

  <tr bgcolor=white> 
    <td align=right> <span $style_normal> 5. 
    <td> <span $style_normal> <b> PERF_SYS% Server Performance Metrics </b>
    <td> <span $style_normal> <b> <a href='/cgi-bin/$P.pl?$mode,$instance,D,PERF_SYS%'> Recent (L${from_days}D) </a>   </b>
    <td> <span $style_normal> <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF_SYS%, Avg'> Historical AVG</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF_SYS%, Max'> Historical MAX</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF_SYS%, Min'> Historical MIN</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF_SYS%, Sum'> Historical SUM</a>   </b>

  <tr bgcolor=white> 
    <td align=right> <span $style_normal> 6. 
    <td> <span $style_normal> <b> PERF_SYS%CPU% Server CPU Performance Metrics </b>
    <td> <span $style_normal> <b> <a href='/cgi-bin/$P.pl?$mode,$instance,D,PERF_SYS%CPU%'> Recent (L${from_days}D) </a>   </b>
    <td> <span $style_normal> <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF_SYS%CPU%, Avg'> Historical AVG</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF_SYS%CPU%, Max'> Historical MAX</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF_SYS%CPU%, Min'> Historical MIN</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF_SYS%CPU%, Sum'> Historical SUM</a>   </b>

  <tr bgcolor=white> 
    <td align=right> <span $style_normal> 7. 
    <td> <span $style_normal> <b> PERF_SYS%MEM% Server Memory Performance Metrics </b>
    <td> <span $style_normal> <b> <a href='/cgi-bin/$P.pl?$mode,$instance,D,PERF_SYS%MEM%'> Recent (L${from_days}D) </a>   </b>
    <td> <span $style_normal> <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF_SYS%MEM%, Avg'> Historical AVG</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF_SYS%MEM%, Max'> Historical MAX</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF_SYS%MEM%, Min'> Historical MIN</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,PERF_SYS%MEM%, Sum'> Historical SUM</a>   </b>

  <tr bgcolor=white> 
    <td align=right> <span $style_normal> 8. 
    <td> <span $style_normal> <b> %SPC% Space-Related Metrics </b>
    <td> <span $style_normal> <b> <a href='/cgi-bin/$P.pl?$mode,$instance,D,%SPC%'> Recent (L${from_days}D) </a>   </b>
    <td> <span $style_normal> <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,%SPC%, Avg'> Historical AVG</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,%SPC%, Max'> Historical MAX</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,%SPC%, Min'> Historical MIN</a>   </b>
     <b> <a href='/cgi-bin/$P.pl?$mode,$instance,H,%SPC%, Sum'> Historical SUM</a>   </b>

  </table> 
  <p>
  <table bgcolor=pink><tr><th><span $style_normal> Note: Execution of this report can be resource intensive. </table>
  
  "); 
}

#-----------------------------------------------------------------------------
sub chartInstance
#-----------------------------------------------------------------------------
{
  &msg("chartInstance - Starting - verb=$verb"); 

  $s_time = time;
  $maxrows = 999999;
  $debug_tr = 0; 
  
  $sql  = "select distinct
	category, 
	parm
      from 
	dbamon.$from_table
      where 
	instance = '$instance' 
        and dbamonmode = '$mode'
	and ts >= dateadd(dd,-$from_days,getdate())
        and category like '${prefix}'
      order by 1, 2
    ";

  &msg("Querying DBAMON.METRICS_DETAIL data for instance_key=($instance) and mode=$mode for the last $recent_days days - sql=$sql");

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;

  &msg("Query elapsed time: $elapsed seconds - Creating a chart for each metric...<br>");

  $selectcount = 0;

  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++; 

    $categ   = shift(@Data);  
    $parm    = shift(@Data);  
  
    push(@metrics_list, "$categ;$parm"); 
  }

  $chartcount = 0; 

  foreach $this_metric (@metrics_list)
  {
    $chartcount++; 
    my @zwords = split(/;/,$this_metric);
    $categ = $zwords[0]; 
    $parm  = $zwords[1]; 
    
    &msg("$chartcount of $selectcount - Found METRIC: $categ/$parm - Creating Chart"); 
    &chartMetric($categ, $parm); 
  }

  $zlen = length($html_out); 
  print "<br>"; 
  &msg("Charts created - Length of html_out: $zlen"); 
  print "<br>$html_out<p>"; 

  if ($selectcount == 0) 
  { 
    print "<tr bgcolor=white><td colspan=5><b>No event history data found for instance: $instance\n";
  }
  print "</table><hr>\n";

  $e_time = time - $s_time;

  &msg("chartInstance - Done - selectcount=$selectcount e_time=$e_time");
}

#----------------------------------------------------------------------
sub chartMetric
#----------------------------------------------------------------------
{
  my $eg_categ = $_[0]; 
  my $eg_parm  = $_[1]; 

  my $eg_debug = 0; 

  &msg("DEBUG - eventGraphPerf - Starting - eg_thishost=$eg_thishost eg_metric=$eg_metric eg_title=$eg_title") if $eg_debug;

  ##             ORDER BY 1 ";
  ## $sql = "SELECT zdate_char, $from_column 
  $sql = "SELECT  dbamon.dbamon.dateconvert_19(ts), $from_column 
              FROM      dbamon.dbamon.$from_table
              WHERE     dbamonmode = '$mode'
                        AND category = '$eg_categ' 
                        and parm     = '$eg_parm'
                        and instance = '$instance'
                        and ts > dateadd(dd, -$from_days, getdate())
  ";

  &msg("DEBUG - Running sql=$sql") if $eg_debug; 

  $sth = $dbh->prepare($sql) || &error('sql_659');
  $sth->execute || &error('sql_660');

  open(DOUT, ">$tmpdata") || &error("Cannot open output tmpdata=$tmpdata - $!");

  my $rows = 0;
  %rowcache = (); 

  while (@Data = $sth->fetchrow_array)
  {
    $ts  = $Data[0];
    $val = $Data[1];

    #---- Edit ts to the format that ploticus likes
    $ts = substr($ts,0,16); 
    $ts =~ s/\-/\./; 

    $rowcache{$ts} = $val; 
  }

  foreach $this_ts ( sort keys %rowcache )
  {
    print DOUT "$this_ts $rowcache{$this_ts}\n";
    $rows++;
  }

  close(DOUT);
  &msg("Wrote sortkeys $rows records to $tmpdata") if $eg_debug;
  $moving_avg = int($rows / 5); 

  if ($eg_debug)
  {
    &msg("Last 10 lines of tmpdata:");
    system("tail -10 $tmpdata");
  }

  #chdir("/opt/dbamon/ploticus");

  $ENV{'DBAMON_PL_FILE'}           = $tmpdata;
  $ENV{'DBAMON_PL_TITLE1'}         = "Instance: $instance" ;
  $ENV{'DBAMON_PL_TITLE2'}         = "Metric: $eg_categ/$eg_parm - $title2";
  $ENV{'DBAMON_PL_MOVINGAVGCOUNT'} = $moving_avg;
  $ENV{'DBAMON_PL_LASTVAL'}        = $val;

  $cmd = "/opt/dbamon/ploticus/dbamon_pl_run SingleLineUserTitles";
  ##$cmd = "dbamon_pl_run SingleLine";  # TEST

  &msg("Invoking Ploticus - cmd=($cmd)") if $eg_debug;
  $rc = system("$cmd > $tmpout 2>&1");
  &msg("Back from dbamon_pl_run - rc=$rc") if $eg_debug;
  system("cat $tmpout") if $eg_debug;
  &error("Ploticus failed - rc=$rc") if $rc != 0;

  #---- Find PNG_File: name
  open(CMDOUT, "$tmpout") || &error("Cannot open input - tmpout=$tmpout - $!");
  while(<CMDOUT>)
  {
    if (/^PNG_File:/)
    {
      @words = split;
      $png_file = $words[1];
    }
  }

  $png_file_url  = "/dbamon/graphs/dyn/$png_file" if $png_file;
  &msg("Returning PNG file - png_file=$png_file - png_file_long=$png_file_long") if $eg_debug;

  ##&msg("Chart: <br><img src=$png_file_url>");  
  $html_out .= "<hr><h3> Chart $chartcount of $selectcount - $categ/$parm: </h3> 
<img src=$png_file_url width=610>
  ";  
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
   local($Signal) = @_;
   print "Signal=$Signal\n";
   exit(0);
}

#-----------------------------------------------------------------------------
sub error_html 
#-----------------------------------------------------------------------------
{
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $str2="";
   $str4=" <h2>Insufficient or missing information...</h2>";
   $html_str=$str.$str1.$str2.$str1.$str4;
   print "$html_str\n";
   #print "<h2>Insufficient or missing information...";
   print "<br>\n";
   print "Please correct the following:</h2>";
   print "<p>\n";
   print "<hr><ul>\n";
   foreach( @error_list) {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   print "<hr>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors corrections to make.<p>\n";
   }
}

#-----------------------------------------------------------------------------
#
# Main
#
#-----------------------------------------------------------------------------

&get_request;

@words = split(/,/,$ARGV[0]);
$mode     = $words[0];
$instance = $words[1];
$verb     = $words[2];
$prefix   = $words[3];
$column   = $words[4];

&header("All Charts") unless $ENV{'DBAMON_NOWEB'}; 

&msg("Starting - version=$version - mode=($mode) verb=($verb) instance=($instance) prefix=($prefix) column=($column) - maxrows=$maxrows - http_host=($http_host) script_name=$script_name");

&connectDB;

#---- Call according to parms passed 
if (! $mode) { &error("MODE (1st parm) Must be specified"); }

#---- Log a message
&logMsg("WWWMonitor", $P, $ENV{'REMOTE_ADDR'}, "Starting - instance=$instance verb=$verb");

if ($verb eq "") 
{
  &menuInstance; 
}
elsif ($verb eq "D") 
{
  $from_table  = uc "metrics_detail"; 
  $from_column = "value" ; 
  $from_days   = 30; 
  $title2      = "Last $from_days Days From $from_table"; 
  &chartInstance; 
}
elsif ($verb eq "H") 
{
  $from_table  = uc "metrics_daily"; 
  $from_column = $column; 
  $from_days   = 9999; 
  $title2      = "From $from_table - $from_column Values"; 
  &chartInstance; 
}
else 
{ 
  &error("Unknown verb=($verb) passed");
}

#---- Terminate
&msg("Done");
unlink "$tmpdata", "$tmpout"; 
exit 0;
