#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
#-------------------------------------------------------------------------
#    Name:  dbamon_snapshots.pl
#-------------------------------------------------------------------------
#
# Changes 
#
# 1.00 23Apr12 BB - Initial
#-------------------------------------------------------------------------
$version = "1.00"; 
$| = 1;
chop($P = `basename $0`); 
$P =~ s/\.pl$//g;

push(@INC,"/opt/dbamon/lib");

require "cgi_handlers.pl";
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

$maxrows = 250;
$stop_displaying = 0;

#---- Max these vars global
$in_categ = "";  

#---- PL and CSV Vars and FILES - Start - Should only happen 1 time
mkdir "/opt/dbamon/dat/dyn" if (! -e "/opt/dbamon/dat/dyn"); 
system("ln -s /opt/dbamon/dat/dyn /opt/dbamon/htm/dyn") if ! -e "/opt/dbamon/htm/dyn"; 

$pl_date = getdate(); 
$pl_date =~ s/\///g;
$pl_date =~ s/\://g;
$pl_date =~ s/\-/_/;
##$zdiag .= "new pl_date=($pl_date)\n"; 

#---- Read WWW_Font:

$font = &readRC("WWW_Font:");
$font = "arial" if ! $font;

#---- Set connect string and hostname for URLs
if ($ENV{'HTTPS'} eq "on") { $http_prefix = "https://"; } 
else                       { $http_prefix = "http://"; } 
$http_host = $http_prefix . $ENV{'HTTP_HOST'};

$script_name = $ENV{'SCRIPT_NAME'};

#---- Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

use DBI;
require "cgi_handlers.pl";

#-----------------------------------------------------------------------------
sub snMenu
#-----------------------------------------------------------------------------
{
  &msg("snMenu - Starting"); 
  $s_time = time;
  $maxrows = 999999;
  $debug_tr = 0; 
  
  $recent_days = 7; 
  $hist_days   = 180; 

  my $html_out = ""; 

  $sql  = "select
    [sn_key], count(*)
    FROM [DBAmon].[dbamon].[snapshots] 
    where sn_dbamonmode = '$mode' and sn_instance = '$instance'
    group by sn_key
    order by sn_key desc"; 

  &msg("Querying DBAMON.SNAPSHOTS for instance=($instance) and mode=$mode - sql=$sql");

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;

  $html_out .= "<p>
  <span $style_large><b> DBAmon Snapshot Report(s) for Instance: $instance </b></span>

  <p>
  <table border=0 bgcolor=wheat $style_normal>
  
  <tr bgcolor=cadetblue>
    <th><span $style_normal>Report<br> Date
    <th><span $style_normal>Report<br> Title 
    <th><span $style_normal>Report<br>Rows 
    <th><span $style_normal>Action(s) 
  \n";

  $selectcount = 0;

  $t_trend_high = 4; 
  $t_trend_low  = 0.5; 

  while (@Data = $sth->fetchrow_array)
  {
    $sn_key    = shift(@Data);  
    $sn_rows   = shift(@Data);  
    #---- 20130423_123444_ReportName

    $sn_date  = substr($sn_key, 0,15); 
    $sn_title = substr($sn_key, 16); 

    if ($sn_title eq "Active_Trans") { $out_title = "MSSQL Active Transactions"; } 
    else                             { $out_title = $sn_title } 

    $out_date = substr($sn_date,0,4) . '/' . 
                substr($sn_date,4,2) . '/' . 
                substr($sn_date,6,2) . '-' . 
                substr($sn_date,9,2) . ':' . 
                substr($sn_date,11,2) . ':' . 
                substr($sn_date,13,2); 
    
    $selectcount++; 

    #---- URLs
    #----   http://localhost/cgi-bin/dbamon_metrics.pl?test,GRAW,localhost_MSSQL2,PERF_SQL_BUFFERCACHEHITRATIO,.,30,
    #----   http://localhost//cgi-bin/dbamon_metrics.pl?test,MDAILY,localhost_MSSQL2,DRIVE_PCT_FULL,C
    $urls = " <a href='/cgi-bin/dbamon_snapshots.pl?$mode,$instance,$sn_key'><b> View Report </b></a> "; 

    ##  <td $style_normal> <b> <a href='$http_host/${script_name}?$mode,$verb,$instance,$categ,$parm'>$categ / $parm</a>  </b>

    $sn_rows -= 2;

    $bg = &bgRow;
    $html_out .= "<tr bgcolor=white>
      <td nowrap $style_normal> &nbsp; $out_date &nbsp;
      <td nowrap $style_normal> &nbsp; $out_title &nbsp;
      <td nowrap $style_normal> &nbsp; $sn_rows &nbsp;
      <td nowrap $style_normal> &nbsp; $urls &nbsp;
    "; 
  }

  #---- Display entire table
  print "$html_out 
  </table>
  ";

  if ($selectcount == 0) 
  { 
    print "<tr bgcolor=white><td colspan=5><b>No event history data found for instance: $instance\n";
  }
  print "</table>\n";

  $e_time = time - $s_time;

  &msg("snMenu - Done - selectcount=$selectcount e_time=$e_time");
}

#-----------------------------------------------------------------------------
sub snReportRender
#-----------------------------------------------------------------------------
{
  &msg("snReportRender - Starting"); 
  $s_time = time;
  $maxrows = 999999;
  $debug_tr = 0; 
  
  $recent_days = 7; 
  $hist_days   = 180; 

  my $html_out = ""; 

  $sql  = "select
    sn_seq,
    sn_content
    FROM [DBAmon].[dbamon].[snapshots] 
    where sn_dbamonmode = '$mode' and sn_instance = '$instance' and sn_key = '$in_snkey'
    order by sn_seq"; 

  &msg("Querying DBAMON.SNAPSHOTS for instance=($instance) and mode=$mode - sql=$sql");

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;

  &msg("Query elapsed time: $elapsed seconds - Comparing recent samples to historical data...");

  $html_out .= "<p>
  <span $style_large><b> DBAmon Snapshot Report $in_snkey for Instance: $instance </b></span>
  <p>
  <table border=0 bgcolor=wheat $style_normal>
  ";

  $selectcount = 0;

  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++; 

    $sn_seq       = shift(@Data);  
    $sn_content   = shift(@Data);  

    if ($sn_seq == 0) 
    {
      $html_out    .= "<tr><td colspan=20 bgcolor=white> <span $style_large> <br> &nbsp; <b>$sn_content</b> <br> &nbsp; </span> </td> </tr>\n"; 
    }
    else
    {
      $html_out    .= "$sn_content\n"; 
    }
  }

  #---- Display entire table
  print "$html_out 
  </table>
  ";

  if ($selectcount == 0) 
  { 
    print "<tr bgcolor=white><td colspan=5><b>No event history data found for instance: $instance\n";
  }
  print "</table>\n";

  $e_time = time - $s_time;

  &msg("snReportRender - Done - selectcount=$selectcount e_time=$e_time");
}

#-----------------------------------------------------------------------------
sub snSummary
#-----------------------------------------------------------------------------
{
  $silent_ss = 1; 
  &msg("snSummary - Starting") unless $silet_ss; 
  $s_time = time;
  
  $recent_days = 7; 
  $hist_days   = 180; 

  my $html_out = ""; 

  $sql  = "select
    count(*),
    min(ts),
    max(ts),
    datediff(dd, min(ts), max(ts))
  from dbamon.dbamon.snapshots
  "; 

  ##&msg("Querying DBAMON.SNAPSHOTS for instance=($instance) and mode=$mode - sql=$sql");

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;

  &msg("Query elapsed time: $elapsed seconds - Comparing recent samples to historical data...");

  $html_out .= "<p>
  <span $style_normal><b> Snapshot Summary for Instance: $instance </b></span>
  <p>
  <table border=0 bgcolor=wheat $style_normal>
  <tr bgcolor=cadetblue>
    <th> <span $style_normal> Snapshot Row Count 
    <th> <span $style_normal> Low Timestamp 
    <th> <span $style_normal> High Timestamp 
    <th> <span $style_normal> Low =&gt; High Days 
  ";

  $selectcount = 0;

  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++; 

    $sn_count       = shift(@Data);  
    $sn_mints       = shift(@Data);  
    $sn_maxts       = shift(@Data);  
    $sn_days        = shift(@Data);  

    $html_out    .= "<tr bgcolor=white>
        <td align=right> <span $style_normal> $sn_count 
        <td> <span $style_normal> $sn_mints 
        <td> <span $style_normal> $sn_maxts 
        <td align=right> <span $style_normal> $sn_days 
      "; 
  }

  #---- Display entire table
  print "$html_out 
  </table>
  ";

  print "</table>\n";

  $e_time = time - $s_time;

  &msg("snSummary - Done - selectcount=$selectcount e_time=$e_time") unless $silent_ss;
}

#-----------------------------------------------------------------------------
sub selectHistory
#-----------------------------------------------------------------------------
{
  my $in_categ = $_[0];
  my $in_parm  = $_[1];
  
  my $debug_sh = 0; 

  &msg("    selectHistory - Starting - in_categ=$in_categ in_parm=$in_parm") if $debug_sh; 

  if ($dbamon_repos eq "M")
  {
    $sql2 = "select 
	avg(avg),
        count(*)
      from 
	dbamon.dbamon.metrics_daily
      where 
	instance       = '$instance' 
        and dbamonmode = '$mode'
        and category   = '$in_categ'
        and parm       = '$in_parm'
        and ts > dateadd(dd, -$hist_days, getdate())
    ";
  }
  else
  {
    &error("This SQL is not yet coded for repository ORACLE"); 
  }

  $sth2 = $dbh->prepare($sql2) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth2->execute || &error('Failed_on_DB_execute_in_chgEnt');

  my $avg_avg = -1; 
  my $hist_count = -1; 

  my $selectcount = 0; 

  while (@Data = $sth2->fetchrow_array)
  {
    $avg_avg  = shift(@Data); 
    $hist_count  = shift(@Data); 
    $selectcount++; 
  }

  &msg("      Result - avg_avg=$avg_avg selectcount=$selectcount") if $debug_sh;

  &msg("    selectHistory - Done - Returning $avg_avg") if $debug_sh; 
  return ($avg_avg, $hist_count); 
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
  local($Signal) = @_;
  print "Signal=$Signal\n";
  exit(0);
}

#-----------------------------------------------------------------------------
sub logMsg
#-----------------------------------------------------------------------------
{
  my ($ls_key1, $ls_key2, $ls_key3, $ls_data) = @_;
  my $sql  = "insert into dbamon.log (lo_key1, lo_key2, lo_key3, lo_data) values (\'$ls_key1\', \'$ls_key2\', \'$ls_key3\', \'$ls_data\')";
  $dbh->do($sql) || &error('Failed_on_DB_do_insert_L300');
}

#-----------------------------------------------------------------------------
sub error_html 
#-----------------------------------------------------------------------------
{
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $str2="";
   $str4=" <h2>Insufficient or missing information...</h2>";
   $html_str=$str.$str1.$str2.$str1.$str4;
   print "$html_str\n";
   #print "<h2>Insufficient or missing information...";
   print "<br>\n";
   print "Please correct the following:</h2>";
   print "<p>\n";
   print "<hr><ul>\n";
   foreach( @error_list) {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   print "<hr>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors corrections to make.<p>\n";
   }
      
}

#-----------------------------------------------------------------------------
#
# Main
#
#-----------------------------------------------------------------------------

&get_request;

@words = split(/,/,$ARGV[0]);
$mode     = $words[0];
$instance = $words[1];
$in_snkey = $words[2];

&header("Instance Snapshot Reports") unless $ENV{'DBAMON_NOWEB'}; 

&msg("Starting - version=$version - mode=($mode) verb=($verb) instance=($instance) in_snkey=($in_snkey)");

#---- Connect to DB
&connectDB;

#---- Log a message
&logMsg("WWWMonitor", $P, $ENV{'REMOTE_ADDR'}, "Starting - instance=$instance in_snkey=$in_snkey"); 

#---- Call according to parms passed 
if (! $mode) 
{ 
  &error("MODE (1st parm) Must be specified");
}
if (! $instance) 
{ 
  &error("INSTANCE (2nd parm) Must be specified");
}
if (! $in_snkey) 
{
  &snSummary; 
  &snMenu; 
}
else 
{ 
  &snReportRender; 
}

#---- Terminate
&msg("Done");
exit 0;
